﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace MainApp
{
	class AdoClient
	{
		public static AdoClient Instance { get; } = new AdoClient();

		private string connString;
		private SqlConnection conn;
		

		public bool SetConnection(string server, string database, string uid, string password)
		{
			connString = $"server={server}; database={database}; uid={uid}; pwd={password};";

			using (conn = new SqlConnection(connString))
			{
				try
				{
					conn.Open();
					conn.Close();
				}
				catch (Exception ex)
				{
					Debug.WriteLine(ex.Message);
					return false;
				}
			}

			return true;
		}

		public DataSet Query(string sql)
		{
			using (conn = new SqlConnection(connString))
			{
				conn.Open();

				SqlDataAdapter adapter = new SqlDataAdapter(sql, conn);
				DataSet dataSet = new DataSet();
				adapter.Fill(dataSet);

				conn.Close();
				return dataSet;
			}
		}

		public DataSet Query(string sql, int pageStart, int pageSize, string tableName)
		{
			using (conn = new SqlConnection(connString))
			{
				conn.Open();

				SqlDataAdapter adapter = new SqlDataAdapter(sql, conn);
				DataSet dataSet = new DataSet();
				adapter.Fill(dataSet, pageStart, pageSize, tableName);

				conn.Close();
				return dataSet;
			}
		}

		public int NonQuery(string sql)
		{
			using (conn = new SqlConnection(connString))
			{
				conn.Open();

				SqlCommand cmd = new SqlCommand(sql, conn);
				return cmd.ExecuteNonQuery();
			}
		}
	}
}
