﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MainApp.Controls
{
	public partial class Paging_Control : UserControl
	{
		const int PAGE_SIZE = 10;
		int _pageStartIdx = 0;
		string _tableName = "Employees";

		public Paging_Control()
		{
			InitializeComponent();
			InitInstance();
		}

		private void InitInstance()
		{
			if (!AdoClient.Instance.SetConnection("peacecloud.synology.me,21433", "Study", "study", "Study123$"))
			{
				MessageBox.Show("Cannot access database.");
				return;
			}

			DoWork(0);
		}

		private void BindTableToGridView(DataSet dataSet)
		{
			mainGridView.SuspendLayout();
			mainGridView.DataSource = dataSet;
			mainGridView.DataMember = _tableName;
			mainGridView.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
			mainGridView.ResumeLayout();
		}

		private void DoWork(int pageStart = 0, int pageSize = PAGE_SIZE)
		{
			BindTableToGridView(GetData(pageStart, pageSize));

			pageLabel.Text = $"- {_pageStartIdx / PAGE_SIZE + 1} -";
		}

		private DataSet GetData(int pageStart = 0, int pageSize = PAGE_SIZE)
		{
			return AdoClient.Instance.Query("SELECT * FROM EMPLOYEE", pageStart, pageSize, _tableName);
		}

		private void prevButton_Click(object sender, EventArgs e)
		{
			if (_pageStartIdx - PAGE_SIZE < 0)
				return;

			_pageStartIdx -= PAGE_SIZE;
			DoWork(_pageStartIdx);
		}

		private void nextButton_Click(object sender, EventArgs e)
		{
			_pageStartIdx += PAGE_SIZE;
			DoWork(_pageStartIdx);
		}
	}
}
